/[gentoo-x86]/eclass/python.eclass
Gentoo

Diff of /eclass/python.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.121 Revision 1.156
1# Copyright 1999-2011 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/python.eclass,v 1.121 2011/07/08 07:41:56 djc Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/python.eclass,v 1.156 2012/08/16 07:46:15 patrick Exp $
4 4
5# @ECLASS: python.eclass 5# @ECLASS: python.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Gentoo Python Project <python@gentoo.org> 7# Gentoo Python Project <python@gentoo.org>
8# @BLURB: Eclass for Python packages 8# @BLURB: Eclass for Python packages
9# @DESCRIPTION: 9# @DESCRIPTION:
10# The python eclass contains miscellaneous, useful functions for Python packages. 10# The python eclass contains miscellaneous, useful functions for Python packages.
11 11
12# Must call inherit before EXPORT_FUNCTIONS to avoid QA warning.
13if [[ -z "${_PYTHON_ECLASS_INHERITED}" ]]; then
12inherit multilib 14 inherit multilib
15fi
13 16
17# Export pkg_setup every time to avoid issues with eclass inheritance order.
18if ! has "${EAPI:-0}" 0 1 2 3 || { has "${EAPI:-0}" 2 3 && [[ -n "${PYTHON_USE_WITH}" || -n "${PYTHON_USE_WITH_OR}" ]]; }; then
19 EXPORT_FUNCTIONS pkg_setup
20fi
21
22# Avoid processing this eclass more than once.
23if [[ -z "${_PYTHON_ECLASS_INHERITED}" ]]; then
24_PYTHON_ECLASS_INHERITED="1"
25
14if ! has "${EAPI:-0}" 0 1 2 3; then 26if ! has "${EAPI:-0}" 0 1 2 3 4; then
15 die "API of python.eclass in EAPI=\"${EAPI}\" not established" 27 die "API of python.eclass in EAPI=\"${EAPI}\" not established"
16fi 28fi
17 29
18_CPYTHON2_GLOBALLY_SUPPORTED_ABIS=(2.4 2.5 2.6 2.7) 30_CPYTHON2_GLOBALLY_SUPPORTED_ABIS=(2.4 2.5 2.6 2.7)
19_CPYTHON3_GLOBALLY_SUPPORTED_ABIS=(3.0 3.1 3.2 3.3) 31_CPYTHON3_GLOBALLY_SUPPORTED_ABIS=(3.1 3.2)
20_JYTHON_GLOBALLY_SUPPORTED_ABIS=(2.5-jython) 32_JYTHON_GLOBALLY_SUPPORTED_ABIS=(2.5-jython)
33_PYPY_GLOBALLY_SUPPORTED_ABIS=(2.7-pypy-1.7 2.7-pypy-1.8 2.7-pypy-1.9)
21_PYTHON_GLOBALLY_SUPPORTED_ABIS=(${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]} ${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]} ${_JYTHON_GLOBALLY_SUPPORTED_ABIS[@]}) 34_PYTHON_GLOBALLY_SUPPORTED_ABIS=(${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]} ${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]} ${_JYTHON_GLOBALLY_SUPPORTED_ABIS[@]} ${_PYPY_GLOBALLY_SUPPORTED_ABIS[@]})
22 35
23# ================================================================================================ 36# ================================================================================================
24# ===================================== HANDLING OF METADATA ===================================== 37# ===================================== HANDLING OF METADATA =====================================
25# ================================================================================================ 38# ================================================================================================
26 39
58 pattern="$2" 71 pattern="$2"
59 72
60 if [[ "${pattern}" == *"-cpython" ]]; then 73 if [[ "${pattern}" == *"-cpython" ]]; then
61 [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+$ && "${PYTHON_ABI}" == ${pattern%-cpython} ]] 74 [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+$ && "${PYTHON_ABI}" == ${pattern%-cpython} ]]
62 elif [[ "${pattern}" == *"-jython" ]]; then 75 elif [[ "${pattern}" == *"-jython" ]]; then
76 [[ "${PYTHON_ABI}" == ${pattern} ]]
77 elif [[ "${pattern}" == *"-pypy-"* ]]; then
63 [[ "${PYTHON_ABI}" == ${pattern} ]] 78 [[ "${PYTHON_ABI}" == ${pattern} ]]
64 else 79 else
65 if [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+$ ]]; then 80 if [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+$ ]]; then
66 [[ "${PYTHON_ABI}" == ${pattern} ]] 81 [[ "${PYTHON_ABI}" == ${pattern} ]]
67 elif [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+-jython$ ]]; then 82 elif [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+-jython$ ]]; then
68 [[ "${PYTHON_ABI%-jython}" == ${pattern} ]] 83 [[ "${PYTHON_ABI%-jython}" == ${pattern} ]]
84 elif [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+-pypy-[[:digit:]]+\.[[:digit:]]+$ ]]; then
85 [[ "${PYTHON_ABI%-pypy-*}" == ${pattern} ]]
69 else 86 else
70 die "${FUNCNAME}(): Unrecognized Python ABI '${PYTHON_ABI}'" 87 die "${FUNCNAME}(): Unrecognized Python ABI '${PYTHON_ABI}'"
71 fi 88 fi
72 fi 89 fi
73 else 90 else
77 if _python_check_python_abi_matching "${PYTHON_ABI}" "${pattern}"; then 94 if _python_check_python_abi_matching "${PYTHON_ABI}" "${pattern}"; then
78 return 0 95 return 0
79 fi 96 fi
80 done <<< "${patterns}" 97 done <<< "${patterns}"
81 98
99 return 1
100 fi
101}
102
103_python_implementation() {
104 if [[ "${CATEGORY}/${PN}" == "dev-lang/python" ]]; then
105 return 0
106 elif [[ "${CATEGORY}/${PN}" == "dev-java/jython" ]]; then
107 return 0
108 elif [[ "${CATEGORY}/${PN}" == "dev-python/pypy" ]]; then
109 return 0
110 else
82 return 1 111 return 1
83 fi 112 fi
84} 113}
85 114
86_python_package_supporting_installation_for_multiple_python_abis() { 115_python_package_supporting_installation_for_multiple_python_abis() {
226 else 255 else
227 die "Invalid syntax of PYTHON_DEPEND" 256 die "Invalid syntax of PYTHON_DEPEND"
228 fi 257 fi
229} 258}
230 259
260if _python_implementation; then
231DEPEND=">=app-admin/eselect-python-20091230" 261 DEPEND=">=app-admin/eselect-python-20091230"
232RDEPEND="${DEPEND}" 262 RDEPEND="${DEPEND}"
263 PDEPEND="app-admin/python-updater"
264fi
233 265
234if [[ -n "${PYTHON_DEPEND}" ]]; then 266if [[ -n "${PYTHON_DEPEND}" ]]; then
235 _python_parse_PYTHON_DEPEND 267 _python_parse_PYTHON_DEPEND
236else 268else
237 _PYTHON_ATOMS=("dev-lang/python") 269 _PYTHON_ATOMS=("dev-lang/python")
276 _PYTHON_USE_WITH_ATOMS="${_PYTHON_USE_WITH_ATOMS_ARRAY[@]}" 308 _PYTHON_USE_WITH_ATOMS="${_PYTHON_USE_WITH_ATOMS_ARRAY[@]}"
277 fi 309 fi
278 if [[ -n "${PYTHON_USE_WITH_OPT}" ]]; then 310 if [[ -n "${PYTHON_USE_WITH_OPT}" ]]; then
279 _PYTHON_USE_WITH_ATOMS="${PYTHON_USE_WITH_OPT}? ( ${_PYTHON_USE_WITH_ATOMS} )" 311 _PYTHON_USE_WITH_ATOMS="${PYTHON_USE_WITH_OPT}? ( ${_PYTHON_USE_WITH_ATOMS} )"
280 fi 312 fi
281 DEPEND+=" ${_PYTHON_USE_WITH_ATOMS}" 313 DEPEND+="${DEPEND:+ }${_PYTHON_USE_WITH_ATOMS}"
282 RDEPEND+=" ${_PYTHON_USE_WITH_ATOMS}" 314 RDEPEND+="${RDEPEND:+ }${_PYTHON_USE_WITH_ATOMS}"
283 unset _PYTHON_ATOM _PYTHON_USE_WITH_ATOMS _PYTHON_USE_WITH_ATOMS_ARRAY 315 unset _PYTHON_ATOM _PYTHON_USE_WITH_ATOMS _PYTHON_USE_WITH_ATOMS_ARRAY
284fi 316fi
285 317
286unset _PYTHON_ATOMS 318unset _PYTHON_ATOMS
287 319
288# ================================================================================================ 320# ================================================================================================
289# =================================== MISCELLANEOUS FUNCTIONS ==================================== 321# =================================== MISCELLANEOUS FUNCTIONS ====================================
290# ================================================================================================ 322# ================================================================================================
291
292_python_implementation() {
293 if [[ "${CATEGORY}/${PN}" == "dev-lang/python" ]]; then
294 return 0
295 elif [[ "${CATEGORY}/${PN}" == "dev-java/jython" ]]; then
296 return 0
297 else
298 return 1
299 fi
300}
301 323
302_python_abi-specific_local_scope() { 324_python_abi-specific_local_scope() {
303 [[ " ${FUNCNAME[@]:2} " =~ " "(_python_final_sanity_checks|python_execute_function|python_mod_optimize|python_mod_cleanup)" " ]] 325 [[ " ${FUNCNAME[@]:2} " =~ " "(_python_final_sanity_checks|python_execute_function|python_mod_optimize|python_mod_cleanup)" " ]]
304} 326}
305 327
377 _CYAN= 399 _CYAN=
378 _NORMAL= 400 _NORMAL=
379 fi 401 fi
380} 402}
381 403
382unset PYTHON_PKG_SETUP_EXECUTED
383
384_python_check_python_pkg_setup_execution() { 404_python_check_python_pkg_setup_execution() {
385 [[ " ${FUNCNAME[@]:1} " =~ " "(python_set_active_version|python_pkg_setup)" " ]] && return 405 [[ " ${FUNCNAME[@]:1} " =~ " "(python_set_active_version|python_pkg_setup)" " ]] && return
386 406
387 if ! has "${EAPI:-0}" 0 1 2 3 && [[ -z "${PYTHON_PKG_SETUP_EXECUTED}" ]]; then 407 if ! has "${EAPI:-0}" 0 1 2 3 && [[ -z "${PYTHON_PKG_SETUP_EXECUTED}" ]]; then
388 die "python_pkg_setup() not called" 408 die "python_pkg_setup() not called"
456 fi 476 fi
457 477
458 PYTHON_PKG_SETUP_EXECUTED="1" 478 PYTHON_PKG_SETUP_EXECUTED="1"
459} 479}
460 480
461if ! has "${EAPI:-0}" 0 1 2 3 || { has "${EAPI:-0}" 2 3 && [[ -n "${PYTHON_USE_WITH}" || -n "${PYTHON_USE_WITH_OR}" ]]; }; then
462 EXPORT_FUNCTIONS pkg_setup
463fi
464
465_PYTHON_SHEBANG_BASE_PART_REGEX='^#![[:space:]]*([^[:space:]]*/usr/bin/env[[:space:]]+)?([^[:space:]]*/)?(jython|python)' 481_PYTHON_SHEBANG_BASE_PART_REGEX='^#![[:space:]]*([^[:space:]]*/usr/bin/env[[:space:]]+)?([^[:space:]]*/)?(jython|pypy-c|python)'
466 482
467# @FUNCTION: python_convert_shebangs 483# @FUNCTION: python_convert_shebangs
468# @USAGE: [-q|--quiet] [-r|--recursive] [-x|--only-executables] [--] <Python_ABI|Python_version> <file|directory> [files|directories] 484# @USAGE: [-q|--quiet] [-r|--recursive] [-x|--only-executables] [--] <Python_ABI|Python_version> <file|directory> [files|directories]
469# @DESCRIPTION: 485# @DESCRIPTION:
470# Convert shebangs in specified files. Directories can be specified only with --recursive option. 486# Convert shebangs in specified files. Directories can be specified only with --recursive option.
471python_convert_shebangs() { 487python_convert_shebangs() {
472 _python_check_python_pkg_setup_execution 488 _python_check_python_pkg_setup_execution
473 489
474 local argument file files=() only_executables="0" python_interpreter quiet="0" recursive="0" 490 local argument file files=() only_executables="0" python_interpreter quiet="0" recursive="0" shebangs_converted="0"
475 491
476 while (($#)); do 492 while (($#)); do
477 case "$1" in 493 case "$1" in
478 -r|--recursive) 494 -r|--recursive)
479 recursive="1" 495 recursive="1"
534 [[ "${only_executables}" == "1" && ! -x "${file}" ]] && continue 550 [[ "${only_executables}" == "1" && ! -x "${file}" ]] && continue
535 551
536 if [[ "$(head -n1 "${file}")" =~ ${_PYTHON_SHEBANG_BASE_PART_REGEX} ]]; then 552 if [[ "$(head -n1 "${file}")" =~ ${_PYTHON_SHEBANG_BASE_PART_REGEX} ]]; then
537 [[ "$(sed -ne "2p" "${file}")" =~ ^"# Gentoo '".*"' wrapper script generated by python_generate_wrapper_scripts()"$ ]] && continue 553 [[ "$(sed -ne "2p" "${file}")" =~ ^"# Gentoo '".*"' wrapper script generated by python_generate_wrapper_scripts()"$ ]] && continue
538 554
555 shebangs_converted="1"
556
539 if [[ "${quiet}" == "0" ]]; then 557 if [[ "${quiet}" == "0" ]]; then
540 einfo "Converting shebang in '${file}'" 558 einfo "Converting shebang in '${file}'"
541 fi 559 fi
542 560
543 sed -e "1s:^#![[:space:]]*\([^[:space:]]*/usr/bin/env[[:space:]]\)\?[[:space:]]*\([^[:space:]]*/\)\?\(jython\|python\)\([[:digit:]]\+\(\.[[:digit:]]\+\)\?\)\?\(\$\|[[:space:]].*\):#!\1\2${python_interpreter}\6:" -i "${file}" || die "Conversion of shebang in '${file}' failed" 561 sed -e "1s:^#![[:space:]]*\([^[:space:]]*/usr/bin/env[[:space:]]\)\?[[:space:]]*\([^[:space:]]*/\)\?\(jython\|pypy-c\|python\)\([[:digit:]]\+\(\.[[:digit:]]\+\)\?\)\?\(\$\|[[:space:]].*\):#!\1\2${python_interpreter}\6:" -i "${file}" || die "Conversion of shebang in '${file}' failed"
562 fi
563 done
564
565 if [[ "${shebangs_converted}" == "0" ]]; then
566 ewarn "${FUNCNAME}(): Python scripts not found"
544 fi 567 fi
568}
569
570# @FUNCTION: python_clean_py-compile_files
571# @USAGE: [-q|--quiet]
572# @DESCRIPTION:
573# Clean py-compile files to disable byte-compilation.
574python_clean_py-compile_files() {
575 _python_check_python_pkg_setup_execution
576
577 local file files=() quiet="0"
578
579 while (($#)); do
580 case "$1" in
581 -q|--quiet)
582 quiet="1"
583 ;;
584 -*)
585 die "${FUNCNAME}(): Unrecognized option '$1'"
586 ;;
587 *)
588 die "${FUNCNAME}(): Invalid usage"
589 ;;
590 esac
591 shift
592 done
593
594 while read -d $'\0' -r file; do
595 files+=("${file#./}")
596 done < <(find -name py-compile -type f -print0)
597
598 for file in "${files[@]}"; do
599 if [[ "${quiet}" == "0" ]]; then
600 einfo "Cleaning '${file}' file"
601 fi
602 echo "#!/bin/sh" > "${file}"
545 done 603 done
546} 604}
547 605
548# @FUNCTION: python_clean_installation_image 606# @FUNCTION: python_clean_installation_image
549# @USAGE: [-q|--quiet] 607# @USAGE: [-q|--quiet]
787 die "Active version of CPython 3 is not supported by ${CATEGORY}/${PF}" 845 die "Active version of CPython 3 is not supported by ${CATEGORY}/${PF}"
788 fi 846 fi
789 else 847 else
790 python3_version="" 848 python3_version=""
791 fi 849 fi
850 fi
851
852 if [[ -z "${python2_version}" && -z "${python3_version}" ]]; then
853 eerror "${CATEGORY}/${PF} requires at least one of the following packages:"
854 for PYTHON_ABI in "${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}" "${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}"; do
855 if ! _python_check_python_abi_matching --patterns-list "${PYTHON_ABI}" "${RESTRICT_PYTHON_ABIS}"; then
856 eerror " dev-lang/python:${PYTHON_ABI}"
857 fi
858 done
859 die "No supported version of CPython installed"
792 fi 860 fi
793 861
794 if [[ -n "${python2_version}" && "${python_version}" == "2."* && "${python_version}" != "${python2_version}" ]]; then 862 if [[ -n "${python2_version}" && "${python_version}" == "2."* && "${python_version}" != "${python2_version}" ]]; then
795 eerror "Python wrapper is configured incorrectly or '${EPREFIX}/usr/bin/python2' symlink" 863 eerror "Python wrapper is configured incorrectly or '${EPREFIX}/usr/bin/python2' symlink"
796 eerror "is set incorrectly. Use \`eselect python\` to fix configuration." 864 eerror "is set incorrectly. Use \`eselect python\` to fix configuration."
954 python_default_function() { 1022 python_default_function() {
955 emake "$@" 1023 emake "$@"
956 } 1024 }
957 elif [[ "${EBUILD_PHASE}" == "test" ]]; then 1025 elif [[ "${EBUILD_PHASE}" == "test" ]]; then
958 python_default_function() { 1026 python_default_function() {
1027 # Stolen from portage's _eapi0_src_test()
1028 local emake_cmd="${MAKE:-make} ${MAKEOPTS} ${EXTRA_EMAKE}"
959 if emake -j1 -n check &> /dev/null; then 1029 if ${emake_cmd} -j1 -n check &> /dev/null; then
960 emake -j1 check "$@" 1030 ${emake_cmd} -j1 check "$@"
961 elif emake -j1 -n test &> /dev/null; then 1031 elif ${emake_cmd} -j1 -n test &> /dev/null; then
962 emake -j1 test "$@" 1032 ${emake_cmd} -j1 test "$@"
963 fi 1033 fi
964 } 1034 }
965 elif [[ "${EBUILD_PHASE}" == "install" ]]; then 1035 elif [[ "${EBUILD_PHASE}" == "install" ]]; then
966 python_default_function() { 1036 python_default_function() {
967 emake DESTDIR="${D}" install "$@" 1037 emake DESTDIR="${D}" install "$@"
998 iterated_PYTHON_ABIS="${PYTHON_ABIS}" 1068 iterated_PYTHON_ABIS="${PYTHON_ABIS}"
999 fi 1069 fi
1000 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do 1070 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do
1001 if [[ "${EBUILD_PHASE}" == "test" ]] && _python_check_python_abi_matching --patterns-list "${PYTHON_ABI}" "${PYTHON_TESTS_RESTRICTED_ABIS}"; then 1071 if [[ "${EBUILD_PHASE}" == "test" ]] && _python_check_python_abi_matching --patterns-list "${PYTHON_ABI}" "${PYTHON_TESTS_RESTRICTED_ABIS}"; then
1002 if [[ "${quiet}" == "0" ]]; then 1072 if [[ "${quiet}" == "0" ]]; then
1003 echo " ${_GREEN}*${_NORMAL} ${_BLUE}Testing of ${CATEGORY}/${PF} with $(python_get_implementation) $(python_get_version) skipped${_NORMAL}" 1073 echo " ${_GREEN}*${_NORMAL} ${_BLUE}Testing of ${CATEGORY}/${PF} with $(python_get_implementation_and_version) skipped${_NORMAL}"
1004 fi 1074 fi
1005 continue 1075 continue
1006 fi 1076 fi
1007 1077
1008 _python_prepare_flags 1078 _python_prepare_flags
1009 1079
1010 if [[ "${quiet}" == "0" ]]; then 1080 if [[ "${quiet}" == "0" ]]; then
1011 if [[ -n "${action_message_template}" ]]; then 1081 if [[ -n "${action_message_template}" ]]; then
1012 eval "action_message=\"${action_message_template}\"" 1082 eval "action_message=\"${action_message_template}\""
1013 else 1083 else
1014 action_message="${action} of ${CATEGORY}/${PF} with $(python_get_implementation) $(python_get_version)..." 1084 action_message="${action} of ${CATEGORY}/${PF} with $(python_get_implementation_and_version)..."
1015 fi 1085 fi
1016 echo " ${_GREEN}*${_NORMAL} ${_BLUE}${action_message}${_NORMAL}" 1086 echo " ${_GREEN}*${_NORMAL} ${_BLUE}${action_message}${_NORMAL}"
1017 fi 1087 fi
1018 1088
1019 if [[ "${separate_build_dirs}" == "1" ]]; then 1089 if [[ "${separate_build_dirs}" == "1" ]]; then
1043 1113
1044 if [[ "${return_code}" -ne 0 ]]; then 1114 if [[ "${return_code}" -ne 0 ]]; then
1045 if [[ -n "${failure_message_template}" ]]; then 1115 if [[ -n "${failure_message_template}" ]]; then
1046 eval "failure_message=\"${failure_message_template}\"" 1116 eval "failure_message=\"${failure_message_template}\""
1047 else 1117 else
1048 failure_message="${action} failed with $(python_get_implementation) $(python_get_version) in ${function}() function" 1118 failure_message="${action} failed with $(python_get_implementation_and_version) in ${function}() function"
1049 fi 1119 fi
1050 1120
1051 if [[ "${nonfatal}" == "1" ]]; then 1121 if [[ "${nonfatal}" == "1" ]]; then
1052 if [[ "${quiet}" == "0" ]]; then 1122 if [[ "${quiet}" == "0" ]]; then
1053 ewarn "${failure_message}" 1123 ewarn "${failure_message}"
1224import os 1294import os
1225import re 1295import re
1226import subprocess 1296import subprocess
1227import sys 1297import sys
1228 1298
1229cpython_re = re.compile(r"^python(\d+\.\d+)$") 1299cpython_ABI_re = re.compile(r"^(\d+\.\d+)$")
1300jython_ABI_re = re.compile(r"^(\d+\.\d+)-jython$")
1301pypy_ABI_re = re.compile(r"^\d+\.\d+-pypy-(\d+\.\d+)$")
1302cpython_interpreter_re = re.compile(r"^python(\d+\.\d+)$")
1230jython_re = re.compile(r"^jython(\d+\.\d+)$") 1303jython_interpreter_re = re.compile(r"^jython(\d+\.\d+)$")
1304pypy_interpreter_re = re.compile(r"^pypy-c(\d+\.\d+)$")
1231python_shebang_re = re.compile(r"^#! *(${EPREFIX}/usr/bin/python|(${EPREFIX})?/usr/bin/env +(${EPREFIX}/usr/bin/)?python)") 1305cpython_shebang_re = re.compile(r"^#![ \t]*(?:${EPREFIX}/usr/bin/python|(?:${EPREFIX})?/usr/bin/env[ \t]+(?:${EPREFIX}/usr/bin/)?python)")
1306python_shebang_options_re = re.compile(r"^#![ \t]*${EPREFIX}/usr/bin/(?:jython|pypy-c|python)(?:\d+(?:\.\d+)?)?[ \t]+(-\S)")
1232python_verification_output_re = re.compile("^GENTOO_PYTHON_TARGET_SCRIPT_PATH supported\n$") 1307python_verification_output_re = re.compile("^GENTOO_PYTHON_TARGET_SCRIPT_PATH supported\n$")
1233 1308
1234def get_PYTHON_ABI(EPYTHON): 1309pypy_versions_mapping = {
1235 cpython_matched = cpython_re.match(EPYTHON) 1310 "1.5": "2.7",
1236 jython_matched = jython_re.match(EPYTHON) 1311 "1.6": "2.7",
1312 "1.7": "2.7",
1313 "1.8": "2.7",
1314 "1.9": "2.7",
1315}
1316
1317def get_PYTHON_ABI(python_interpreter):
1318 cpython_matched = cpython_interpreter_re.match(python_interpreter)
1319 jython_matched = jython_interpreter_re.match(python_interpreter)
1320 pypy_matched = pypy_interpreter_re.match(python_interpreter)
1237 if cpython_matched is not None: 1321 if cpython_matched is not None:
1238 PYTHON_ABI = cpython_matched.group(1) 1322 PYTHON_ABI = cpython_matched.group(1)
1239 elif jython_matched is not None: 1323 elif jython_matched is not None:
1240 PYTHON_ABI = jython_matched.group(1) + "-jython" 1324 PYTHON_ABI = jython_matched.group(1) + "-jython"
1325 elif pypy_matched is not None:
1326 PYTHON_ABI = pypy_versions_mapping[pypy_matched.group(1)] + "-pypy-" + pypy_matched.group(1)
1241 else: 1327 else:
1242 PYTHON_ABI = None 1328 PYTHON_ABI = None
1243 return PYTHON_ABI 1329 return PYTHON_ABI
1244 1330
1331def get_python_interpreter(PYTHON_ABI):
1332 cpython_matched = cpython_ABI_re.match(PYTHON_ABI)
1333 jython_matched = jython_ABI_re.match(PYTHON_ABI)
1334 pypy_matched = pypy_ABI_re.match(PYTHON_ABI)
1335 if cpython_matched is not None:
1336 python_interpreter = "python" + cpython_matched.group(1)
1337 elif jython_matched is not None:
1338 python_interpreter = "jython" + jython_matched.group(1)
1339 elif pypy_matched is not None:
1340 python_interpreter = "pypy-c" + pypy_matched.group(1)
1341 else:
1342 python_interpreter = None
1343 return python_interpreter
1344
1245EOF 1345EOF
1246 if [[ "$?" != "0" ]]; then 1346 if [[ "$?" != "0" ]]; then
1247 die "${FUNCNAME}(): Generation of '$1' failed" 1347 die "${FUNCNAME}(): Generation of '$1' failed"
1248 fi 1348 fi
1249 if [[ "${respect_EPYTHON}" == "1" ]]; then 1349 if [[ "${respect_EPYTHON}" == "1" ]]; then
1250 cat << EOF >> "${file}" 1350 cat << EOF >> "${file}"
1251EPYTHON = os.environ.get("EPYTHON") 1351python_interpreter = os.environ.get("EPYTHON")
1252if EPYTHON: 1352if python_interpreter:
1253 PYTHON_ABI = get_PYTHON_ABI(EPYTHON) 1353 PYTHON_ABI = get_PYTHON_ABI(python_interpreter)
1254 if PYTHON_ABI is None: 1354 if PYTHON_ABI is None:
1255 sys.stderr.write("EPYTHON variable has unrecognized value '%s'\n" % EPYTHON) 1355 sys.stderr.write("%s: EPYTHON variable has unrecognized value '%s'\n" % (sys.argv[0], python_interpreter))
1256 sys.exit(1) 1356 sys.exit(1)
1257else: 1357else:
1258 try: 1358 try:
1359 environment = os.environ.copy()
1360 environment["ROOT"] = "/"
1259 eselect_process = subprocess.Popen(["${EPREFIX}/usr/bin/eselect", "python", "show"${eselect_python_option:+, $(echo "\"")}${eselect_python_option}${eselect_python_option:+$(echo "\"")}], stdout=subprocess.PIPE) 1361 eselect_process = subprocess.Popen(["${EPREFIX}/usr/bin/eselect", "python", "show"${eselect_python_option:+, $(echo "\"")}${eselect_python_option}${eselect_python_option:+$(echo "\"")}], env=environment, stdout=subprocess.PIPE)
1260 if eselect_process.wait() != 0: 1362 if eselect_process.wait() != 0:
1261 raise ValueError 1363 raise ValueError
1262 except (OSError, ValueError): 1364 except (OSError, ValueError):
1263 sys.stderr.write("Execution of 'eselect python show${eselect_python_option:+ }${eselect_python_option}' failed\n") 1365 sys.stderr.write("%s: Execution of 'eselect python show${eselect_python_option:+ }${eselect_python_option}' failed\n" % sys.argv[0])
1264 sys.exit(1) 1366 sys.exit(1)
1265 1367
1266 EPYTHON = eselect_process.stdout.read() 1368 python_interpreter = eselect_process.stdout.read()
1267 if not isinstance(EPYTHON, str): 1369 if not isinstance(python_interpreter, str):
1268 # Python 3 1370 # Python 3
1269 EPYTHON = EPYTHON.decode() 1371 python_interpreter = python_interpreter.decode()
1270 EPYTHON = EPYTHON.rstrip("\n") 1372 python_interpreter = python_interpreter.rstrip("\n")
1271 1373
1272 PYTHON_ABI = get_PYTHON_ABI(EPYTHON) 1374 PYTHON_ABI = get_PYTHON_ABI(python_interpreter)
1273 if PYTHON_ABI is None: 1375 if PYTHON_ABI is None:
1274 sys.stderr.write("'eselect python show${eselect_python_option:+ }${eselect_python_option}' printed unrecognized value '%s'\n" % EPYTHON) 1376 sys.stderr.write("%s: 'eselect python show${eselect_python_option:+ }${eselect_python_option}' printed unrecognized value '%s'\n" % (sys.argv[0], python_interpreter))
1275 sys.exit(1) 1377 sys.exit(1)
1276 1378
1277wrapper_script_path = os.path.realpath(sys.argv[0]) 1379wrapper_script_path = os.path.realpath(sys.argv[0])
1278target_executable_path = "%s-%s" % (wrapper_script_path, PYTHON_ABI) 1380target_executable_path = "%s-%s" % (wrapper_script_path, PYTHON_ABI)
1279if not os.path.exists(target_executable_path): 1381if not os.path.exists(target_executable_path):
1280 sys.stderr.write("'%s' does not exist\n" % target_executable_path) 1382 sys.stderr.write("%s: '%s' does not exist\n" % (sys.argv[0], target_executable_path))
1281 sys.exit(1) 1383 sys.exit(1)
1282EOF 1384EOF
1283 if [[ "$?" != "0" ]]; then 1385 if [[ "$?" != "0" ]]; then
1284 die "${FUNCNAME}(): Generation of '$1' failed" 1386 die "${FUNCNAME}(): Generation of '$1' failed"
1285 fi 1387 fi
1286 else 1388 else
1287 cat << EOF >> "${file}" 1389 cat << EOF >> "${file}"
1288try: 1390try:
1391 environment = os.environ.copy()
1392 environment["ROOT"] = "/"
1289 eselect_process = subprocess.Popen(["${EPREFIX}/usr/bin/eselect", "python", "show"${eselect_python_option:+, $(echo "\"")}${eselect_python_option}${eselect_python_option:+$(echo "\"")}], stdout=subprocess.PIPE) 1393 eselect_process = subprocess.Popen(["${EPREFIX}/usr/bin/eselect", "python", "show"${eselect_python_option:+, $(echo "\"")}${eselect_python_option}${eselect_python_option:+$(echo "\"")}], env=environment, stdout=subprocess.PIPE)
1290 if eselect_process.wait() != 0: 1394 if eselect_process.wait() != 0:
1291 raise ValueError 1395 raise ValueError
1292except (OSError, ValueError): 1396except (OSError, ValueError):
1293 sys.stderr.write("Execution of 'eselect python show${eselect_python_option:+ }${eselect_python_option}' failed\n") 1397 sys.stderr.write("%s: Execution of 'eselect python show${eselect_python_option:+ }${eselect_python_option}' failed\n" % sys.argv[0])
1294 sys.exit(1) 1398 sys.exit(1)
1295 1399
1296EPYTHON = eselect_process.stdout.read() 1400python_interpreter = eselect_process.stdout.read()
1297if not isinstance(EPYTHON, str): 1401if not isinstance(python_interpreter, str):
1298 # Python 3 1402 # Python 3
1299 EPYTHON = EPYTHON.decode() 1403 python_interpreter = python_interpreter.decode()
1300EPYTHON = EPYTHON.rstrip("\n") 1404python_interpreter = python_interpreter.rstrip("\n")
1301 1405
1302PYTHON_ABI = get_PYTHON_ABI(EPYTHON) 1406PYTHON_ABI = get_PYTHON_ABI(python_interpreter)
1303if PYTHON_ABI is None: 1407if PYTHON_ABI is None:
1304 sys.stderr.write("'eselect python show${eselect_python_option:+ }${eselect_python_option}' printed unrecognized value '%s'\n" % EPYTHON) 1408 sys.stderr.write("%s: 'eselect python show${eselect_python_option:+ }${eselect_python_option}' printed unrecognized value '%s'\n" % (sys.argv[0], python_interpreter))
1305 sys.exit(1) 1409 sys.exit(1)
1306 1410
1307wrapper_script_path = os.path.realpath(sys.argv[0]) 1411wrapper_script_path = os.path.realpath(sys.argv[0])
1308for PYTHON_ABI in [PYTHON_ABI, ${PYTHON_ABIS_list}]: 1412for PYTHON_ABI in [PYTHON_ABI, ${PYTHON_ABIS_list}]:
1309 target_executable_path = "%s-%s" % (wrapper_script_path, PYTHON_ABI) 1413 target_executable_path = "%s-%s" % (wrapper_script_path, PYTHON_ABI)
1310 if os.path.exists(target_executable_path): 1414 if os.path.exists(target_executable_path):
1311 break 1415 break
1312else: 1416else:
1313 sys.stderr.write("No target script exists for '%s'\n" % wrapper_script_path) 1417 sys.stderr.write("%s: No target script exists for '%s'\n" % (sys.argv[0], wrapper_script_path))
1418 sys.exit(1)
1419
1420python_interpreter = get_python_interpreter(PYTHON_ABI)
1421if python_interpreter is None:
1422 sys.stderr.write("%s: Unrecognized Python ABI '%s'\n" % (sys.argv[0], PYTHON_ABI))
1314 sys.exit(1) 1423 sys.exit(1)
1315EOF 1424EOF
1316 if [[ "$?" != "0" ]]; then 1425 if [[ "$?" != "0" ]]; then
1317 die "${FUNCNAME}(): Generation of '$1' failed" 1426 die "${FUNCNAME}(): Generation of '$1' failed"
1318 fi 1427 fi
1319 fi 1428 fi
1320 cat << EOF >> "${file}" 1429 cat << EOF >> "${file}"
1321 1430
1322target_executable = open(target_executable_path, "rb") 1431target_executable = open(target_executable_path, "rb")
1323target_executable_first_line = target_executable.readline() 1432target_executable_first_line = target_executable.readline()
1433target_executable.close()
1324if not isinstance(target_executable_first_line, str): 1434if not isinstance(target_executable_first_line, str):
1325 # Python 3 1435 # Python 3
1326 target_executable_first_line = target_executable_first_line.decode("utf_8", "replace") 1436 target_executable_first_line = target_executable_first_line.decode("utf_8", "replace")
1327 1437
1438options = []
1439python_shebang_options_matched = python_shebang_options_re.match(target_executable_first_line)
1440if python_shebang_options_matched is not None:
1441 options = [python_shebang_options_matched.group(1)]
1442
1328python_shebang_matched = python_shebang_re.match(target_executable_first_line) 1443cpython_shebang_matched = cpython_shebang_re.match(target_executable_first_line)
1329target_executable.close()
1330 1444
1331if python_shebang_matched is not None: 1445if cpython_shebang_matched is not None:
1332 try: 1446 try:
1333 python_interpreter_path = "${EPREFIX}/usr/bin/%s" % EPYTHON 1447 python_interpreter_path = "${EPREFIX}/usr/bin/%s" % python_interpreter
1334 os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"] = "1" 1448 os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"] = "1"
1335 python_verification_process = subprocess.Popen([python_interpreter_path, "-c", "pass"], stdout=subprocess.PIPE) 1449 python_verification_process = subprocess.Popen([python_interpreter_path, "-c", "pass"], stdout=subprocess.PIPE)
1336 del os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"] 1450 del os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"]
1337 if python_verification_process.wait() != 0: 1451 if python_verification_process.wait() != 0:
1338 raise ValueError 1452 raise ValueError
1343 python_verification_output = python_verification_output.decode() 1457 python_verification_output = python_verification_output.decode()
1344 1458
1345 if not python_verification_output_re.match(python_verification_output): 1459 if not python_verification_output_re.match(python_verification_output):
1346 raise ValueError 1460 raise ValueError
1347 1461
1348 if cpython_re.match(EPYTHON) is not None: 1462 if cpython_interpreter_re.match(python_interpreter) is not None:
1349 os.environ["GENTOO_PYTHON_PROCESS_NAME"] = os.path.basename(sys.argv[0]) 1463 os.environ["GENTOO_PYTHON_PROCESS_NAME"] = os.path.basename(sys.argv[0])
1350 os.environ["GENTOO_PYTHON_WRAPPER_SCRIPT_PATH"] = sys.argv[0] 1464 os.environ["GENTOO_PYTHON_WRAPPER_SCRIPT_PATH"] = sys.argv[0]
1351 os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH"] = target_executable_path 1465 os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH"] = target_executable_path
1352 1466
1353 if hasattr(os, "execv"): 1467 if hasattr(os, "execv"):
1354 os.execv(python_interpreter_path, [python_interpreter_path] + sys.argv) 1468 os.execv(python_interpreter_path, [python_interpreter_path] + options + sys.argv)
1355 else: 1469 else:
1356 sys.exit(subprocess.Popen([python_interpreter_path] + sys.argv).wait()) 1470 sys.exit(subprocess.Popen([python_interpreter_path] + options + sys.argv).wait())
1357 except (KeyboardInterrupt, SystemExit): 1471 except (KeyboardInterrupt, SystemExit):
1358 raise 1472 raise
1359 except: 1473 except:
1360 pass 1474 pass
1361 for variable in ("GENTOO_PYTHON_PROCESS_NAME", "GENTOO_PYTHON_WRAPPER_SCRIPT_PATH", "GENTOO_PYTHON_TARGET_SCRIPT_PATH", "GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"): 1475 for variable in ("GENTOO_PYTHON_PROCESS_NAME", "GENTOO_PYTHON_WRAPPER_SCRIPT_PATH", "GENTOO_PYTHON_TARGET_SCRIPT_PATH", "GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"):
1403 fi 1517 fi
1404 1518
1405 _python_check_python_pkg_setup_execution 1519 _python_check_python_pkg_setup_execution
1406 _python_initialize_prefix_variables 1520 _python_initialize_prefix_variables
1407 1521
1408 local b file files=() intermediate_installation_images_directory PYTHON_ABI quiet="0" regex shebang version_executable wrapper_scripts=() wrapper_scripts_set=() 1522 local absolute_file b file files=() intermediate_installation_images_directory PYTHON_ABI quiet="0" regex shebang version_executable wrapper_scripts=() wrapper_scripts_set=()
1409 1523
1410 while (($#)); do 1524 while (($#)); do
1411 case "$1" in 1525 case "$1" in
1412 -q|--quiet) 1526 -q|--quiet)
1413 quiet="1" 1527 quiet="1"
1495 break 1609 break
1496 fi 1610 fi
1497 done 1611 done
1498 fi 1612 fi
1499 1613
1500 [[ "${version_executable}" == "0" || ! -x "${file}" ]] && continue 1614 [[ "${version_executable}" == "0" ]] && continue
1501 1615
1616 if [[ -L "${file}" ]]; then
1617 absolute_file="$(readlink "${file}")"
1618 if [[ "${absolute_file}" == /* ]]; then
1619 absolute_file="${intermediate_installation_images_directory}/${PYTHON_ABI}${EPREFIX}/${absolute_file##/}"
1620 else
1621 if [[ "${file}" == */* ]]; then
1622 absolute_file="${intermediate_installation_images_directory}/${PYTHON_ABI}${EPREFIX}/${file%/*}/${absolute_file}"
1623 else
1624 absolute_file="${intermediate_installation_images_directory}/${PYTHON_ABI}${EPREFIX}/${absolute_file}"
1625 fi
1626 fi
1627 else
1628 absolute_file="${intermediate_installation_images_directory}/${PYTHON_ABI}${EPREFIX}/${file}"
1629 fi
1630
1631 [[ ! -x "${absolute_file}" ]] && continue
1632
1502 shebang="$(head -n1 "${file}")" || die "Extraction of shebang from '${file}' failed" 1633 shebang="$(head -n1 "${absolute_file}")" || die "Extraction of shebang from '${absolute_file}' failed"
1503 1634
1504 if [[ "${version_executable}" == "2" ]]; then 1635 if [[ "${version_executable}" == "2" ]]; then
1505 wrapper_scripts+=("${ED}${file}") 1636 wrapper_scripts+=("${ED}${file}")
1506 elif [[ "${version_executable}" == "1" ]]; then 1637 elif [[ "${version_executable}" == "1" ]]; then
1507 if [[ "${shebang}" =~ ${_PYTHON_SHEBANG_BASE_PART_REGEX}([[:digit:]]+(\.[[:digit:]]+)?)?($|[[:space:]]+) ]]; then 1638 if [[ "${shebang}" =~ ${_PYTHON_SHEBANG_BASE_PART_REGEX}([[:digit:]]+(\.[[:digit:]]+)?)?($|[[:space:]]+) ]]; then
1518 fi 1649 fi
1519 1650
1520 mv "${file}" "${file}-${PYTHON_ABI}" || die "Renaming of '${file}' failed" 1651 mv "${file}" "${file}-${PYTHON_ABI}" || die "Renaming of '${file}' failed"
1521 1652
1522 if [[ "${shebang}" =~ ${_PYTHON_SHEBANG_BASE_PART_REGEX}[[:digit:]]*($|[[:space:]]+) ]]; then 1653 if [[ "${shebang}" =~ ${_PYTHON_SHEBANG_BASE_PART_REGEX}[[:digit:]]*($|[[:space:]]+) ]]; then
1654 if [[ -L "${file}-${PYTHON_ABI}" ]]; then
1655 python_convert_shebangs $([[ "${quiet}" == "1" ]] && echo --quiet) "${PYTHON_ABI}" "${absolute_file}"
1656 else
1523 python_convert_shebangs $([[ "${quiet}" == "1" ]] && echo --quiet) "${PYTHON_ABI}" "${file}-${PYTHON_ABI}" 1657 python_convert_shebangs $([[ "${quiet}" == "1" ]] && echo --quiet) "${PYTHON_ABI}" "${file}-${PYTHON_ABI}"
1658 fi
1524 fi 1659 fi
1525 done 1660 done
1526 1661
1527 popd > /dev/null || die "popd failed" 1662 popd > /dev/null || die "popd failed"
1528 1663
1664 # This is per bug #390691, without the duplication refactor, and with
1665 # the 3-way structure per comment #6. This enable users with old
1666 # coreutils to upgrade a lot easier (you need to upgrade python+portage
1667 # before coreutils can be upgraded).
1668 if ROOT="/" has_version '>=sys-apps/coreutils-6.9.90'; then
1669 cp -fr --preserve=all --no-preserve=context "${intermediate_installation_images_directory}/${PYTHON_ABI}/"* "${D}" || die "Merging of intermediate installation image for Python ABI '${PYTHON_ABI} into installation image failed"
1529 if ROOT="/" has_version sys-apps/coreutils; then 1670 elif ROOT="/" has_version sys-apps/coreutils; then
1530 cp -fr --preserve=all "${intermediate_installation_images_directory}/${PYTHON_ABI}/"* "${D}" || die "Merging of intermediate installation image for Python ABI '${PYTHON_ABI} into installation image failed" 1671 cp -fr --preserve=all "${intermediate_installation_images_directory}/${PYTHON_ABI}/"* "${D}" || die "Merging of intermediate installation image for Python ABI '${PYTHON_ABI} into installation image failed"
1531 else 1672 else
1532 cp -fpr "${intermediate_installation_images_directory}/${PYTHON_ABI}/"* "${D}" || die "Merging of intermediate installation image for Python ABI '${PYTHON_ABI} into installation image failed" 1673 cp -fpr "${intermediate_installation_images_directory}/${PYTHON_ABI}/"* "${D}" || die "Merging of intermediate installation image for Python ABI '${PYTHON_ABI} into installation image failed"
1533 fi 1674 fi
1534 done 1675 done
1553 stdout = sys.stdout.buffer 1694 stdout = sys.stdout.buffer
1554else: 1695else:
1555 # Python 2 1696 # Python 2
1556 stdout = sys.stdout 1697 stdout = sys.stdout
1557 1698
1699python_wrapper_scripts_file = open('${T}/python_wrapper_scripts', 'rb')
1558files = set(open('${T}/python_wrapper_scripts', 'rb').read().rstrip(${b}'\x00').split(${b}'\x00')) 1700files = set(python_wrapper_scripts_file.read().rstrip(${b}'\x00').split(${b}'\x00'))
1701python_wrapper_scripts_file.close()
1559 1702
1560for file in sorted(files): 1703for file in sorted(files):
1561 stdout.write(file) 1704 stdout.write(file)
1562 stdout.write(${b}'\x00')" || die "${FUNCNAME}(): Failure of extraction of set of wrapper scripts") 1705 stdout.write(${b}'\x00')" || die "${FUNCNAME}(): Failure of extraction of set of wrapper scripts")
1563 1706
1628 # python-updater checks PYTHON_REQUESTED_ACTIVE_VERSION variable. 1771 # python-updater checks PYTHON_REQUESTED_ACTIVE_VERSION variable.
1629 PYTHON_REQUESTED_ACTIVE_VERSION="$1" 1772 PYTHON_REQUESTED_ACTIVE_VERSION="$1"
1630} 1773}
1631 1774
1632# @FUNCTION: python_need_rebuild 1775# @FUNCTION: python_need_rebuild
1776# @DESCRIPTION:
1633# @DESCRIPTION: Mark current package for rebuilding by python-updater after 1777# Mark current package for rebuilding by python-updater after
1634# switching of active version of Python. 1778# switching of active version of Python.
1635python_need_rebuild() { 1779python_need_rebuild() {
1636 if _python_package_supporting_installation_for_multiple_python_abis; then 1780 if _python_package_supporting_installation_for_multiple_python_abis; then
1637 die "${FUNCNAME}() cannot be used in ebuilds of packages supporting installation for multiple Python ABIs" 1781 die "${FUNCNAME}() cannot be used in ebuilds of packages supporting installation for multiple Python ABIs"
1638 fi 1782 fi
1648 1792
1649# ================================================================================================ 1793# ================================================================================================
1650# ======================================= GETTER FUNCTIONS ======================================= 1794# ======================================= GETTER FUNCTIONS =======================================
1651# ================================================================================================ 1795# ================================================================================================
1652 1796
1653_PYTHON_ABI_EXTRACTION_COMMAND='import platform 1797_PYTHON_ABI_EXTRACTION_COMMAND=\
1798'import platform
1654import sys 1799import sys
1655sys.stdout.write(".".join(str(x) for x in sys.version_info[:2])) 1800sys.stdout.write(".".join(str(x) for x in sys.version_info[:2]))
1656if platform.system()[:4] == "Java": 1801if platform.system()[:4] == "Java":
1657 sys.stdout.write("-jython")' 1802 sys.stdout.write("-jython")
1803elif hasattr(platform, "python_implementation") and platform.python_implementation() == "PyPy":
1804 sys.stdout.write("-pypy-" + ".".join(str(x) for x in sys.pypy_version_info[:2]))'
1658 1805
1659_python_get_implementation() { 1806_python_get_implementation() {
1660 local ignore_invalid="0" 1807 local ignore_invalid="0"
1661 1808
1662 while (($#)); do 1809 while (($#)); do
1684 1831
1685 if [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+$ ]]; then 1832 if [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+$ ]]; then
1686 echo "CPython" 1833 echo "CPython"
1687 elif [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+-jython$ ]]; then 1834 elif [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+-jython$ ]]; then
1688 echo "Jython" 1835 echo "Jython"
1836 elif [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+-pypy-[[:digit:]]+\.[[:digit:]]+$ ]]; then
1837 echo "PyPy"
1689 else 1838 else
1690 if [[ "${ignore_invalid}" == "0" ]]; then 1839 if [[ "${ignore_invalid}" == "0" ]]; then
1691 die "${FUNCNAME}(): Unrecognized Python ABI '$1'" 1840 die "${FUNCNAME}(): Unrecognized Python ABI '$1'"
1692 fi 1841 fi
1693 fi 1842 fi
1756 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs" 1905 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1757 fi 1906 fi
1758 _python_calculate_PYTHON_ABIS 1907 _python_calculate_PYTHON_ABIS
1759 PYTHON_ABI="${PYTHON_ABIS##* }" 1908 PYTHON_ABI="${PYTHON_ABIS##* }"
1760 elif [[ "${python2}" == "1" ]]; then 1909 elif [[ "${python2}" == "1" ]]; then
1761 PYTHON_ABI="$(eselect python show --python2 --ABI)" 1910 PYTHON_ABI="$(ROOT="/" eselect python show --python2 --ABI)"
1762 if [[ -z "${PYTHON_ABI}" ]]; then 1911 if [[ -z "${PYTHON_ABI}" ]]; then
1763 die "${FUNCNAME}(): Active version of CPython 2 not set" 1912 die "${FUNCNAME}(): Active version of CPython 2 not set"
1764 elif [[ "${PYTHON_ABI}" != "2."* ]]; then 1913 elif [[ "${PYTHON_ABI}" != "2."* ]]; then
1765 die "${FUNCNAME}(): Internal error in \`eselect python show --python2\`" 1914 die "${FUNCNAME}(): Internal error in \`eselect python show --python2\`"
1766 fi 1915 fi
1767 elif [[ "${python3}" == "1" ]]; then 1916 elif [[ "${python3}" == "1" ]]; then
1768 PYTHON_ABI="$(eselect python show --python3 --ABI)" 1917 PYTHON_ABI="$(ROOT="/" eselect python show --python3 --ABI)"
1769 if [[ -z "${PYTHON_ABI}" ]]; then 1918 if [[ -z "${PYTHON_ABI}" ]]; then
1770 die "${FUNCNAME}(): Active version of CPython 3 not set" 1919 die "${FUNCNAME}(): Active version of CPython 3 not set"
1771 elif [[ "${PYTHON_ABI}" != "3."* ]]; then 1920 elif [[ "${PYTHON_ABI}" != "3."* ]]; then
1772 die "${FUNCNAME}(): Internal error in \`eselect python show --python3\`" 1921 die "${FUNCNAME}(): Internal error in \`eselect python show --python3\`"
1773 fi 1922 fi
1802 else 1951 else
1803 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then 1952 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1804 python_interpreter="python${PYTHON_ABI}" 1953 python_interpreter="python${PYTHON_ABI}"
1805 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then 1954 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1806 python_interpreter="jython${PYTHON_ABI%-jython}" 1955 python_interpreter="jython${PYTHON_ABI%-jython}"
1956 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
1957 python_interpreter="pypy-c${PYTHON_ABI#*-pypy-}"
1807 fi 1958 fi
1808 1959
1809 if [[ "${absolute_path_output}" == "1" ]]; then 1960 if [[ "${absolute_path_output}" == "1" ]]; then
1810 echo -n "${EPREFIX}/usr/bin/${python_interpreter}" 1961 echo -n "${EPREFIX}/usr/bin/${python_interpreter}"
1811 else 1962 else
1904 if [[ "${EAPI:-0}" == "0" ]]; then 2055 if [[ "${EAPI:-0}" == "0" ]]; then
1905 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then 2056 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1906 echo "=dev-lang/python-${PYTHON_ABI}*" 2057 echo "=dev-lang/python-${PYTHON_ABI}*"
1907 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then 2058 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1908 echo "=dev-java/jython-${PYTHON_ABI%-jython}*" 2059 echo "=dev-java/jython-${PYTHON_ABI%-jython}*"
2060 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
2061 echo "=dev-python/pypy-${PYTHON_ABI#*-pypy-}*"
1909 fi 2062 fi
1910 else 2063 else
1911 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then 2064 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1912 echo "dev-lang/python:${PYTHON_ABI}" 2065 echo "dev-lang/python:${PYTHON_ABI}"
1913 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then 2066 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1914 echo "dev-java/jython:${PYTHON_ABI%-jython}" 2067 echo "dev-java/jython:${PYTHON_ABI%-jython}"
2068 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
2069 echo "dev-python/pypy:${PYTHON_ABI#*-pypy-}"
1915 fi 2070 fi
1916 fi 2071 fi
1917} 2072}
1918 2073
1919# @FUNCTION: python_get_includedir 2074# @FUNCTION: python_get_includedir
1966 2121
1967 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then 2122 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1968 echo "${prefix}usr/include/python${PYTHON_ABI}" 2123 echo "${prefix}usr/include/python${PYTHON_ABI}"
1969 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then 2124 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1970 echo "${prefix}usr/share/jython-${PYTHON_ABI%-jython}/Include" 2125 echo "${prefix}usr/share/jython-${PYTHON_ABI%-jython}/Include"
2126 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
2127 echo "${prefix}usr/$(get_libdir)/pypy${PYTHON_ABI#*-pypy-}/include"
1971 fi 2128 fi
1972} 2129}
1973 2130
1974# @FUNCTION: python_get_libdir 2131# @FUNCTION: python_get_libdir
1975# @USAGE: [-b|--base-path] [-f|--final-ABI] 2132# @USAGE: [-b|--base-path] [-f|--final-ABI]
1976# @DESCRIPTION: 2133# @DESCRIPTION:
1977# Print path to Python library directory. 2134# Print path to Python standard library directory.
1978# If --base-path option is specified, then path not prefixed with "/" is printed. 2135# If --base-path option is specified, then path not prefixed with "/" is printed.
1979# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used. 2136# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1980python_get_libdir() { 2137python_get_libdir() {
1981 _python_check_python_pkg_setup_execution 2138 _python_check_python_pkg_setup_execution
1982 2139
2021 2178
2022 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then 2179 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
2023 echo "${prefix}usr/$(get_libdir)/python${PYTHON_ABI}" 2180 echo "${prefix}usr/$(get_libdir)/python${PYTHON_ABI}"
2024 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then 2181 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
2025 echo "${prefix}usr/share/jython-${PYTHON_ABI%-jython}/Lib" 2182 echo "${prefix}usr/share/jython-${PYTHON_ABI%-jython}/Lib"
2183 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
2184 die "${FUNCNAME}(): PyPy has multiple standard library directories"
2026 fi 2185 fi
2027} 2186}
2028 2187
2029# @FUNCTION: python_get_sitedir 2188# @FUNCTION: python_get_sitedir
2030# @USAGE: [-b|--base-path] [-f|--final-ABI] 2189# @USAGE: [-b|--base-path] [-f|--final-ABI]
2033# If --base-path option is specified, then path not prefixed with "/" is printed. 2192# If --base-path option is specified, then path not prefixed with "/" is printed.
2034# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used. 2193# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
2035python_get_sitedir() { 2194python_get_sitedir() {
2036 _python_check_python_pkg_setup_execution 2195 _python_check_python_pkg_setup_execution
2037 2196
2038 local final_ABI="0" options=() 2197 local base_path="0" final_ABI="0" prefix PYTHON_ABI="${PYTHON_ABI}"
2039 2198
2040 while (($#)); do 2199 while (($#)); do
2041 case "$1" in 2200 case "$1" in
2042 -b|--base-path) 2201 -b|--base-path)
2043 options+=("$1") 2202 base_path="1"
2044 ;; 2203 ;;
2045 -f|--final-ABI) 2204 -f|--final-ABI)
2046 final_ABI="1" 2205 final_ABI="1"
2047 options+=("$1")
2048 ;; 2206 ;;
2049 -*) 2207 -*)
2050 die "${FUNCNAME}(): Unrecognized option '$1'" 2208 die "${FUNCNAME}(): Unrecognized option '$1'"
2051 ;; 2209 ;;
2052 *) 2210 *)
2053 die "${FUNCNAME}(): Invalid usage" 2211 die "${FUNCNAME}(): Invalid usage"
2054 ;; 2212 ;;
2055 esac 2213 esac
2056 shift 2214 shift
2057 done 2215 done
2216
2217 if [[ "${base_path}" == "0" ]]; then
2218 prefix="/"
2219 fi
2058 2220
2059 if [[ "${final_ABI}" == "1" ]]; then 2221 if [[ "${final_ABI}" == "1" ]]; then
2060 if ! _python_package_supporting_installation_for_multiple_python_abis; then 2222 if ! _python_package_supporting_installation_for_multiple_python_abis; then
2061 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs" 2223 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
2062 fi 2224 fi
2225 PYTHON_ABI="$(PYTHON -f --ABI)"
2063 else 2226 else
2064 if _python_package_supporting_installation_for_multiple_python_abis && ! _python_abi-specific_local_scope; then 2227 if _python_package_supporting_installation_for_multiple_python_abis; then
2228 if ! _python_abi-specific_local_scope; then
2065 die "${FUNCNAME}() should be used in ABI-specific local scope" 2229 die "${FUNCNAME}() should be used in ABI-specific local scope"
2066 fi 2230 fi
2231 else
2232 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
2067 fi 2233 fi
2234 fi
2068 2235
2069 echo "$(python_get_libdir "${options[@]}")/site-packages" 2236 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
2237 echo "${prefix}usr/$(get_libdir)/python${PYTHON_ABI}/site-packages"
2238 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
2239 echo "${prefix}usr/share/jython-${PYTHON_ABI%-jython}/Lib/site-packages"
2240 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
2241 echo "${prefix}usr/$(get_libdir)/pypy${PYTHON_ABI#*-pypy-}/site-packages"
2242 fi
2070} 2243}
2071 2244
2072# @FUNCTION: python_get_library 2245# @FUNCTION: python_get_library
2073# @USAGE: [-b|--base-path] [-f|--final-ABI] [-l|--linker-option] 2246# @USAGE: [-b|--base-path] [-f|--final-ABI] [-l|--linker-option]
2074# @DESCRIPTION: 2247# @DESCRIPTION:
2131 else 2304 else
2132 echo "${prefix}usr/$(get_libdir)/libpython${PYTHON_ABI}$(get_libname)" 2305 echo "${prefix}usr/$(get_libdir)/libpython${PYTHON_ABI}$(get_libname)"
2133 fi 2306 fi
2134 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then 2307 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
2135 die "${FUNCNAME}(): Jython does not have shared library" 2308 die "${FUNCNAME}(): Jython does not have shared library"
2309 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
2310 die "${FUNCNAME}(): PyPy does not have shared library"
2136 fi 2311 fi
2137} 2312}
2138 2313
2139# @FUNCTION: python_get_version 2314# @FUNCTION: python_get_version
2140# @USAGE: [-f|--final-ABI] [-l|--language] [--full] [--major] [--minor] [--micro] 2315# @USAGE: [-f|--final-ABI] [-l|--language] [--full] [--major] [--minor] [--micro]
2141# @DESCRIPTION: 2316# @DESCRIPTION:
2142# Print Python version. 2317# Print version of Python implementation.
2143# --full, --major, --minor and --micro options cannot be specified simultaneously. 2318# --full, --major, --minor and --micro options cannot be specified simultaneously.
2144# If --full, --major, --minor and --micro options are not specified, then "${major_version}.${minor_version}" is printed. 2319# If --full, --major, --minor and --micro options are not specified, then "${major_version}.${minor_version}" is printed.
2145# If --language option is specified, then Python language version is printed. 2320# If --language option is specified, then version of Python language is printed.
2146# --language and --full options cannot be specified simultaneously. 2321# --language and --full options cannot be specified simultaneously.
2147# --language and --micro options cannot be specified simultaneously. 2322# --language and --micro options cannot be specified simultaneously.
2148# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used. 2323# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
2149python_get_version() { 2324python_get_version() {
2150 _python_check_python_pkg_setup_execution 2325 _python_check_python_pkg_setup_execution
2213 else 2388 else
2214 echo "${language_version}" 2389 echo "${language_version}"
2215 fi 2390 fi
2216 else 2391 else
2217 if [[ "${full}" == "1" ]]; then 2392 if [[ "${full}" == "1" ]]; then
2218 python_command="from sys import version_info; print('.'.join(str(x) for x in version_info[:3]))" 2393 python_command="import sys; print('.'.join(str(x) for x in getattr(sys, 'pypy_version_info', sys.version_info)[:3]))"
2219 elif [[ "${major}" == "1" ]]; then 2394 elif [[ "${major}" == "1" ]]; then
2220 python_command="from sys import version_info; print(version_info[0])" 2395 python_command="import sys; print(getattr(sys, 'pypy_version_info', sys.version_info)[0])"
2221 elif [[ "${minor}" == "1" ]]; then 2396 elif [[ "${minor}" == "1" ]]; then
2222 python_command="from sys import version_info; print(version_info[1])" 2397 python_command="import sys; print(getattr(sys, 'pypy_version_info', sys.version_info)[1])"
2223 elif [[ "${micro}" == "1" ]]; then 2398 elif [[ "${micro}" == "1" ]]; then
2224 python_command="from sys import version_info; print(version_info[2])" 2399 python_command="import sys; print(getattr(sys, 'pypy_version_info', sys.version_info)[2])"
2225 else 2400 else
2226 if [[ -n "${PYTHON_ABI}" && "${final_ABI}" == "0" ]]; then 2401 if [[ -n "${PYTHON_ABI}" && "${final_ABI}" == "0" ]]; then
2227 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then 2402 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
2228 echo "${PYTHON_ABI}" 2403 echo "${PYTHON_ABI}"
2229 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then 2404 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
2230 echo "${PYTHON_ABI%-jython}" 2405 echo "${PYTHON_ABI%-jython}"
2406 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
2407 echo "${PYTHON_ABI#*-pypy-}"
2231 fi 2408 fi
2232 return 2409 return
2233 fi 2410 fi
2234 python_command="from sys import version_info; print('.'.join(str(x) for x in version_info[:2]))" 2411 python_command="from sys import version_info; print('.'.join(str(x) for x in version_info[:2]))"
2235 fi 2412 fi
2240 "$(PYTHON ${PYTHON_ABI})" -c "${python_command}" 2417 "$(PYTHON ${PYTHON_ABI})" -c "${python_command}"
2241 fi 2418 fi
2242 fi 2419 fi
2243} 2420}
2244 2421
2422# @FUNCTION: python_get_implementation_and_version
2423# @USAGE: [-f|--final-ABI]
2424# @DESCRIPTION:
2425# Print name and version of Python implementation.
2426# If version of Python implementation is not bound to version of Python language, then
2427# version of Python language is additionally printed.
2428# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
2429python_get_implementation_and_version() {
2430 _python_check_python_pkg_setup_execution
2431
2432 local final_ABI="0" PYTHON_ABI="${PYTHON_ABI}"
2433
2434 while (($#)); do
2435 case "$1" in
2436 -f|--final-ABI)
2437 final_ABI="1"
2438 ;;
2439 -*)
2440 die "${FUNCNAME}(): Unrecognized option '$1'"
2441 ;;
2442 *)
2443 die "${FUNCNAME}(): Invalid usage"
2444 ;;
2445 esac
2446 shift
2447 done
2448
2449 if [[ "${final_ABI}" == "1" ]]; then
2450 if ! _python_package_supporting_installation_for_multiple_python_abis; then
2451 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
2452 fi
2453 PYTHON_ABI="$(PYTHON -f --ABI)"
2454 else
2455 if _python_package_supporting_installation_for_multiple_python_abis; then
2456 if ! _python_abi-specific_local_scope; then
2457 die "${FUNCNAME}() should be used in ABI-specific local scope"
2458 fi
2459 else
2460 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
2461 fi
2462 fi
2463
2464 if [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+-[[:alnum:]]+-[[:digit:]]+\.[[:digit:]]+$ ]]; then
2465 echo "$(_python_get_implementation "${PYTHON_ABI}") ${PYTHON_ABI##*-} (Python ${PYTHON_ABI%%-*})"
2466 else
2467 echo "$(_python_get_implementation "${PYTHON_ABI}") ${PYTHON_ABI%%-*}"
2468 fi
2469}
2470
2245# ================================================================================================ 2471# ================================================================================================
2246# ================================ FUNCTIONS FOR RUNNING OF TESTS ================================ 2472# ================================ FUNCTIONS FOR RUNNING OF TESTS ================================
2247# ================================================================================================ 2473# ================================================================================================
2248 2474
2249# @ECLASS-VARIABLE: PYTHON_TEST_VERBOSITY 2475# @ECLASS-VARIABLE: PYTHON_TEST_VERBOSITY
2255_python_test_hook() { 2481_python_test_hook() {
2256 if [[ "$#" -ne 1 ]]; then 2482 if [[ "$#" -ne 1 ]]; then
2257 die "${FUNCNAME}() requires 1 argument" 2483 die "${FUNCNAME}() requires 1 argument"
2258 fi 2484 fi
2259 2485
2260 if _python_package_supporting_installation_for_multiple_python_abis && [[ "$(type -t "${FUNCNAME[3]}_$1_hook")" == "function" ]]; then 2486 if _python_package_supporting_installation_for_multiple_python_abis && [[ "$(type -t "${_PYTHON_TEST_FUNCTION}_$1_hook")" == "function" ]]; then
2261 "${FUNCNAME[3]}_$1_hook" 2487 "${_PYTHON_TEST_FUNCTION}_$1_hook"
2262 fi 2488 fi
2263} 2489}
2264 2490
2265# @FUNCTION: python_execute_nosetests 2491# @FUNCTION: python_execute_nosetests
2266# @USAGE: [-P|--PYTHONPATH PYTHONPATH] [-s|--separate-build-dirs] [--] [arguments] 2492# @USAGE: [-P|--PYTHONPATH PYTHONPATH] [-s|--separate-build-dirs] [--] [arguments]
2300 python_test_function() { 2526 python_test_function() {
2301 local evaluated_PYTHONPATH 2527 local evaluated_PYTHONPATH
2302 2528
2303 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\"" 2529 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\""
2304 2530
2305 _python_test_hook pre 2531 _PYTHON_TEST_FUNCTION="python_execute_nosetests" _python_test_hook pre
2306 2532
2307 if [[ -n "${evaluated_PYTHONPATH}" ]]; then 2533 if [[ -n "${evaluated_PYTHONPATH}" ]]; then
2308 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@"${_NORMAL} 2534 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@"${_NORMAL}
2309 PYTHONPATH="${evaluated_PYTHONPATH}" nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@" || return "$?" 2535 PYTHONPATH="${evaluated_PYTHONPATH}" nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@" || return "$?"
2310 else 2536 else
2311 echo ${_BOLD}nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@"${_NORMAL} 2537 echo ${_BOLD}nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@"${_NORMAL}
2312 nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@" || return "$?" 2538 nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@" || return "$?"
2313 fi 2539 fi
2314 2540
2315 _python_test_hook post 2541 _PYTHON_TEST_FUNCTION="python_execute_nosetests" _python_test_hook post
2316 } 2542 }
2317 if _python_package_supporting_installation_for_multiple_python_abis; then 2543 if _python_package_supporting_installation_for_multiple_python_abis; then
2318 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@" 2544 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@"
2319 else 2545 else
2320 if [[ -n "${separate_build_dirs}" ]]; then 2546 if [[ -n "${separate_build_dirs}" ]]; then
2364 python_test_function() { 2590 python_test_function() {
2365 local evaluated_PYTHONPATH 2591 local evaluated_PYTHONPATH
2366 2592
2367 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\"" 2593 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\""
2368 2594
2369 _python_test_hook pre 2595 _PYTHON_TEST_FUNCTION="python_execute_py.test" _python_test_hook pre
2370 2596
2371 if [[ -n "${evaluated_PYTHONPATH}" ]]; then 2597 if [[ -n "${evaluated_PYTHONPATH}" ]]; then
2372 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" py.test $([[ "${PYTHON_TEST_VERBOSITY}" -ge 2 ]] && echo -v) "$@"${_NORMAL} 2598 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" py.test $([[ "${PYTHON_TEST_VERBOSITY}" -ge 2 ]] && echo -v) "$@"${_NORMAL}
2373 PYTHONPATH="${evaluated_PYTHONPATH}" py.test $([[ "${PYTHON_TEST_VERBOSITY}" -ge 2 ]] && echo -v) "$@" || return "$?" 2599 PYTHONPATH="${evaluated_PYTHONPATH}" py.test $([[ "${PYTHON_TEST_VERBOSITY}" -ge 2 ]] && echo -v) "$@" || return "$?"
2374 else 2600 else
2375 echo ${_BOLD}py.test $([[ "${PYTHON_TEST_VERBOSITY}" -gt 1 ]] && echo -v) "$@"${_NORMAL} 2601 echo ${_BOLD}py.test $([[ "${PYTHON_TEST_VERBOSITY}" -gt 1 ]] && echo -v) "$@"${_NORMAL}
2376 py.test $([[ "${PYTHON_TEST_VERBOSITY}" -gt 1 ]] && echo -v) "$@" || return "$?" 2602 py.test $([[ "${PYTHON_TEST_VERBOSITY}" -gt 1 ]] && echo -v) "$@" || return "$?"
2377 fi 2603 fi
2378 2604
2379 _python_test_hook post 2605 _PYTHON_TEST_FUNCTION="python_execute_py.test" _python_test_hook post
2380 } 2606 }
2381 if _python_package_supporting_installation_for_multiple_python_abis; then 2607 if _python_package_supporting_installation_for_multiple_python_abis; then
2382 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@" 2608 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@"
2383 else 2609 else
2384 if [[ -n "${separate_build_dirs}" ]]; then 2610 if [[ -n "${separate_build_dirs}" ]]; then
2428 python_test_function() { 2654 python_test_function() {
2429 local evaluated_PYTHONPATH 2655 local evaluated_PYTHONPATH
2430 2656
2431 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\"" 2657 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\""
2432 2658
2433 _python_test_hook pre 2659 _PYTHON_TEST_FUNCTION="python_execute_trial" _python_test_hook pre
2434 2660
2435 if [[ -n "${evaluated_PYTHONPATH}" ]]; then 2661 if [[ -n "${evaluated_PYTHONPATH}" ]]; then
2436 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@"${_NORMAL} 2662 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@"${_NORMAL}
2437 PYTHONPATH="${evaluated_PYTHONPATH}" trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@" || return "$?" 2663 PYTHONPATH="${evaluated_PYTHONPATH}" trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@" || return "$?"
2438 else 2664 else
2439 echo ${_BOLD}trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@"${_NORMAL} 2665 echo ${_BOLD}trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@"${_NORMAL}
2440 trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@" || return "$?" 2666 trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@" || return "$?"
2441 fi 2667 fi
2442 2668
2443 _python_test_hook post 2669 _PYTHON_TEST_FUNCTION="python_execute_trial" _python_test_hook post
2444 } 2670 }
2445 if _python_package_supporting_installation_for_multiple_python_abis; then 2671 if _python_package_supporting_installation_for_multiple_python_abis; then
2446 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@" 2672 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@"
2447 else 2673 else
2448 if [[ -n "${separate_build_dirs}" ]]; then 2674 if [[ -n "${separate_build_dirs}" ]]; then
2540 if [[ "${EBUILD_PHASE}" == "postinst" ]]; then 2766 if [[ "${EBUILD_PHASE}" == "postinst" ]]; then
2541 [[ -f "${py_file}" && "${compiled_file}" -nt "${py_file}" ]] && continue 2767 [[ -f "${py_file}" && "${compiled_file}" -nt "${py_file}" ]] && continue
2542 else 2768 else
2543 [[ -f "${py_file}" ]] && continue 2769 [[ -f "${py_file}" ]] && continue
2544 fi 2770 fi
2545 echo "${_BLUE}<<< ${compiled_file%[co]}[co]${_NORMAL}"
2546 rm -f "${compiled_file%[co]}"[co] 2771 rm -f "${compiled_file%[co]}"[co]
2547 elif [[ "${compiled_file}" == *\$py.class ]]; then 2772 elif [[ "${compiled_file}" == *\$py.class ]]; then
2548 if [[ "${dir}" == "__pycache__" ]]; then 2773 if [[ "${dir}" == "__pycache__" ]]; then
2549 base_module_name="${compiled_file##*/}" 2774 base_module_name="${compiled_file##*/}"
2550 base_module_name="${base_module_name%\$py.class}" 2775 base_module_name="${base_module_name%\$py.class}"
2555 if [[ "${EBUILD_PHASE}" == "postinst" ]]; then 2780 if [[ "${EBUILD_PHASE}" == "postinst" ]]; then
2556 [[ -f "${py_file}" && "${compiled_file}" -nt "${py_file}" ]] && continue 2781 [[ -f "${py_file}" && "${compiled_file}" -nt "${py_file}" ]] && continue
2557 else 2782 else
2558 [[ -f "${py_file}" ]] && continue 2783 [[ -f "${py_file}" ]] && continue
2559 fi 2784 fi
2560 echo "${_BLUE}<<< ${compiled_file}${_NORMAL}"
2561 rm -f "${compiled_file}" 2785 rm -f "${compiled_file}"
2562 else 2786 else
2563 die "${FUNCNAME}(): Unrecognized file type: '${compiled_file}'" 2787 die "${FUNCNAME}(): Unrecognized file type: '${compiled_file}'"
2564 fi 2788 fi
2565 2789
2566 # Delete empty parent directories. 2790 # Delete empty parent directories.
2567 dir="${compiled_file%/*}" 2791 dir="${compiled_file%/*}"
2568 while [[ "${dir}" != "${root}" ]]; do 2792 while [[ "${dir}" != "${root}" ]]; do
2569 if rmdir "${dir}" 2> /dev/null; then 2793 if ! rmdir "${dir}" 2> /dev/null; then
2570 echo "${_CYAN}<<< ${dir}${_NORMAL}"
2571 else
2572 break 2794 break
2573 fi 2795 fi
2574 dir="${dir%/*}" 2796 dir="${dir%/*}"
2575 done 2797 done
2576 done 2798 done
2698 2920
2699 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do 2921 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do
2700 if ((${#site_packages_dirs[@]})) || ((${#site_packages_files[@]})) || ((${#evaluated_dirs[@]})) || ((${#evaluated_files[@]})); then 2922 if ((${#site_packages_dirs[@]})) || ((${#site_packages_files[@]})) || ((${#evaluated_dirs[@]})) || ((${#evaluated_files[@]})); then
2701 return_code="0" 2923 return_code="0"
2702 stderr="" 2924 stderr=""
2703 ebegin "Compilation and optimization of Python modules for $(python_get_implementation) $(python_get_version)" 2925 ebegin "Compilation and optimization of Python modules for $(python_get_implementation_and_version)"
2704 if ((${#site_packages_dirs[@]})) || ((${#evaluated_dirs[@]})); then 2926 if ((${#site_packages_dirs[@]})) || ((${#evaluated_dirs[@]})); then
2705 for dir in "${site_packages_dirs[@]}"; do 2927 for dir in "${site_packages_dirs[@]}"; do
2706 dirs+=("${root}$(python_get_sitedir)/${dir}") 2928 dirs+=("${root}$(python_get_sitedir)/${dir}")
2707 done 2929 done
2708 for dir in "${evaluated_dirs[@]}"; do 2930 for dir in "${evaluated_dirs[@]}"; do
2709 eval "dirs+=(\"\${root}${dir}\")" 2931 eval "dirs+=(\"\${root}${dir}\")"
2710 done 2932 done
2711 stderr+="${stderr:+$'\n'}$("$(PYTHON)" "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${dirs[@]}" 2>&1)" || return_code="1" 2933 stderr+="${stderr:+$'\n'}$("$(PYTHON)" -m compileall "${options[@]}" "${dirs[@]}" 2>&1)" || return_code="1"
2712 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then 2934 if ! has "$(_python_get_implementation "${PYTHON_ABI}")" Jython PyPy; then
2713 "$(PYTHON)" -O "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${dirs[@]}" &> /dev/null || return_code="1" 2935 "$(PYTHON)" -O -m compileall "${options[@]}" "${dirs[@]}" &> /dev/null || return_code="1"
2714 fi 2936 fi
2715 _python_clean_compiled_modules "${dirs[@]}" 2937 _python_clean_compiled_modules "${dirs[@]}"
2716 fi 2938 fi
2717 if ((${#site_packages_files[@]})) || ((${#evaluated_files[@]})); then 2939 if ((${#site_packages_files[@]})) || ((${#evaluated_files[@]})); then
2718 for file in "${site_packages_files[@]}"; do 2940 for file in "${site_packages_files[@]}"; do
2719 files+=("${root}$(python_get_sitedir)/${file}") 2941 files+=("${root}$(python_get_sitedir)/${file}")
2720 done 2942 done
2721 for file in "${evaluated_files[@]}"; do 2943 for file in "${evaluated_files[@]}"; do
2722 eval "files+=(\"\${root}${file}\")" 2944 eval "files+=(\"\${root}${file}\")"
2723 done 2945 done
2724 stderr+="${stderr:+$'\n'}$("$(PYTHON)" "${root}$(python_get_libdir)/py_compile.py" "${files[@]}" 2>&1)" || return_code="1" 2946 stderr+="${stderr:+$'\n'}$("$(PYTHON)" -m py_compile "${files[@]}" 2>&1)" || return_code="1"
2725 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then 2947 if ! has "$(_python_get_implementation "${PYTHON_ABI}")" Jython PyPy; then
2726 "$(PYTHON)" -O "${root}$(python_get_libdir)/py_compile.py" "${files[@]}" &> /dev/null || return_code="1" 2948 "$(PYTHON)" -O -m py_compile "${files[@]}" &> /dev/null || return_code="1"
2727 fi 2949 fi
2728 _python_clean_compiled_modules "${files[@]}" 2950 _python_clean_compiled_modules "${files[@]}"
2729 fi 2951 fi
2730 eend "${return_code}" 2952 eend "${return_code}"
2731 if [[ -n "${stderr}" ]]; then 2953 if [[ -n "${stderr}" ]]; then
2732 eerror "Syntax errors / warnings in Python modules for $(python_get_implementation) $(python_get_version):" &> /dev/null 2954 eerror "Syntax errors / warnings in Python modules for $(python_get_implementation_and_version):" &> /dev/null
2733 while read stderr_line; do 2955 while read stderr_line; do
2734 eerror " ${stderr_line}" 2956 eerror " ${stderr_line}"
2735 done <<< "${stderr}" 2957 done <<< "${stderr}"
2736 fi 2958 fi
2737 fi 2959 fi
2748 fi 2970 fi
2749 2971
2750 if ((${#other_dirs[@]})) || ((${#other_files[@]})); then 2972 if ((${#other_dirs[@]})) || ((${#other_files[@]})); then
2751 return_code="0" 2973 return_code="0"
2752 stderr="" 2974 stderr=""
2753 ebegin "Compilation and optimization of Python modules placed outside of site-packages directories for $(python_get_implementation) $(python_get_version)" 2975 ebegin "Compilation and optimization of Python modules placed outside of site-packages directories for $(python_get_implementation_and_version)"
2754 if ((${#other_dirs[@]})); then 2976 if ((${#other_dirs[@]})); then
2755 stderr+="${stderr:+$'\n'}$("$(PYTHON ${PYTHON_ABI})" "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${other_dirs[@]}" 2>&1)" || return_code="1" 2977 stderr+="${stderr:+$'\n'}$("$(PYTHON ${PYTHON_ABI})" -m compileall "${options[@]}" "${other_dirs[@]}" 2>&1)" || return_code="1"
2756 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then 2978 if ! has "$(_python_get_implementation "${PYTHON_ABI}")" Jython PyPy; then
2757 "$(PYTHON ${PYTHON_ABI})" -O "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${other_dirs[@]}" &> /dev/null || return_code="1" 2979 "$(PYTHON ${PYTHON_ABI})" -O -m compileall "${options[@]}" "${other_dirs[@]}" &> /dev/null || return_code="1"
2758 fi 2980 fi
2759 _python_clean_compiled_modules "${other_dirs[@]}" 2981 _python_clean_compiled_modules "${other_dirs[@]}"
2760 fi 2982 fi
2761 if ((${#other_files[@]})); then 2983 if ((${#other_files[@]})); then
2762 stderr+="${stderr:+$'\n'}$("$(PYTHON ${PYTHON_ABI})" "${root}$(python_get_libdir)/py_compile.py" "${other_files[@]}" 2>&1)" || return_code="1" 2984 stderr+="${stderr:+$'\n'}$("$(PYTHON ${PYTHON_ABI})" -m py_compile "${other_files[@]}" 2>&1)" || return_code="1"
2763 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" != "Jython" ]]; then 2985 if ! has "$(_python_get_implementation "${PYTHON_ABI}")" Jython PyPy; then
2764 "$(PYTHON ${PYTHON_ABI})" -O "${root}$(python_get_libdir)/py_compile.py" "${other_files[@]}" &> /dev/null || return_code="1" 2986 "$(PYTHON ${PYTHON_ABI})" -O -m py_compile "${other_files[@]}" &> /dev/null || return_code="1"
2765 fi 2987 fi
2766 _python_clean_compiled_modules "${other_files[@]}" 2988 _python_clean_compiled_modules "${other_files[@]}"
2767 fi 2989 fi
2768 eend "${return_code}" 2990 eend "${return_code}"
2769 if [[ -n "${stderr}" ]]; then 2991 if [[ -n "${stderr}" ]]; then
2770 eerror "Syntax errors / warnings in Python modules placed outside of site-packages directories for $(python_get_implementation) $(python_get_version):" &> /dev/null 2992 eerror "Syntax errors / warnings in Python modules placed outside of site-packages directories for $(python_get_implementation_and_version):" &> /dev/null
2771 while read stderr_line; do 2993 while read stderr_line; do
2772 eerror " ${stderr_line}" 2994 eerror " ${stderr_line}"
2773 done <<< "${stderr}" 2995 done <<< "${stderr}"
2774 fi 2996 fi
2775 fi 2997 fi
2955} 3177}
2956 3178
2957# ================================================================================================ 3179# ================================================================================================
2958# ===================================== DEPRECATED FUNCTIONS ===================================== 3180# ===================================== DEPRECATED FUNCTIONS =====================================
2959# ================================================================================================ 3181# ================================================================================================
3182
3183fi # _PYTHON_ECLASS_INHERITED

Legend:
Removed from v.1.121  
changed lines
  Added in v.1.156

  ViewVC Help
Powered by ViewVC 1.1.20